﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Threading;
using Telerik.Windows.Controls.Gauges;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		/// <summary>
		/// Timer to change indicator's value
		/// </summary>
		private DispatcherTimer timer;
		private BoundValue val;

		private Random rnd = new Random();

		public Window1()
		{
			InitializeComponent();

			this.Loaded += new RoutedEventHandler(Window_Loaded);
		}

		private void Window_Loaded(object sender, RoutedEventArgs e)
		{
			val = this.Resources["boundValue"] as BoundValue;

			timer = new DispatcherTimer();
			timer.Interval = TimeSpan.FromSeconds(1);
			timer.Tick += new EventHandler(Timer_Tick);
			timer.Start();
		}

		private void Timer_Tick(object sender, EventArgs e)
		{
			timer.Stop();

			val.NumValue = 100 * rnd.NextDouble();

			timer.Start();
		}
	}

	public class BoundValue : INotifyPropertyChanged
	{
		double _value;

		public double NumValue
		{
			get { return _value; }
			set
			{
				_value = value;
				// Call OnPropertyChanged whenever the property is updated
				OnPropertyChanged("NumValue");
			}
		}

		// Declare event
		public event PropertyChangedEventHandler PropertyChanged;

		// OnPropertyChanged to update property value in binding
		private void OnPropertyChanged(string propName)
		{
			PropertyChangedEventHandler handler = PropertyChanged;
			if (handler != null)
			{
				handler(this, new PropertyChangedEventArgs(propName));
			}
		}
	}
}
